<?php

namespace BodyRep\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * Bodyrep\Entity\Member
 *
 * @ORM\Table(name="member")
 * @ORM\Entity(repositoryClass="BodyRep\Entity\UserRepository")
 */
class Member implements UserInterface
{
    /**
     * @ORM\Column(type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=25, unique=true)
     */
    private $username;
    
    /**
     * @var string $fullname
     *
     * @ORM\Column(name="fullname", type="string")
     */
    private $fullname;
    /**
     * @ORM\Column(type="string", length=32)
     */
    private $salt;

    /**
     * @ORM\Column(type="string", length=40)
     */
    private $password;

    /**
     * @ORM\Column(type="string", length=60, unique=true)
     */
    private $email;

    /**
     * @ORM\Column(name="active", type="integer")
     */
    private $isActive;

    private $roles;

   public function __construct($username, $password = '', $salt = '', $roles = array())
    {
        $this->username = $username;
        $this->password = $password;
        $this->salt = $salt;
        $this->roles = $roles;
    }

    /**
     * @inheritDoc
     */
    public function getUsername()
    {
        return $this->username;
    }


    /**
     * @inheritDoc
     */
    public function getSalt()
    {
        return $this->salt;
    }

    /**
     * @inheritDoc
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * @inheritDoc
     */
    public function getRoles()
    {
        return array('ROLE_USER');
    }

    /**
     * @inheritDoc
     */
    public function eraseCredentials()
    {
    }

    /**
     * Set fullName
     *
     * @param string $fullname
     * @return Member
     */
    public function setfullname($fullname)
    {
        $this->fullname = $fullname;
    
        return $this;
    }

    /**
     * Get fullName
     *
     * @return string 
     */
    public function getFullName()
    {
        return $this->fullname;
    }
    /**
     * Get fullName
     *
     * @return string 
     */
    public function getLink()
    {
        return '/app_dev.php/' . $this->getUsername();
    }
}
